// shard.cpp

/**
*    Copyright (C) 2008 10gen Inc.
*
*    This program is free software: you can redistribute it and/or  modify
*    it under the terms of the GNU Affero General Public License, version 3,
*    as published by the Free Software Foundation.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU Affero General Public License for more details.
*
*    You should have received a copy of the GNU Affero General Public License
*    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "shard.h"
#include "configserver.h"

namespace mongo {
    
    string Shard::modelServer() {
        // TODO: this could move around?
        return configServer.modelServer();
    }

    void Shard::serialize(BSONObjBuilder& to) {
        to.append("name", name);
    }

    void Shard::unserialize(BSONObj& from) {
        name = from.getStringField("name");
        uassert("bad config.shards.name", !name.empty());
    }

} // namespace mongo
